Option Strict Off
Option Explicit On

Module Module1


    Structure ADU_DEVICE_ID
        Dim iVendorId As Short
        Dim iProductId As Short


        <VBFixedString(7), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=7)> Public sSerialNumber As String
    End Structure
    Structure DACardObject
        Dim aduHandle As Long
        Dim sn As String
        Dim CardType As Integer
        Dim IntegerBaud As Long
        Dim WhichPort As String
        Dim PortSpeed As Long
        Dim DIOStructure As Integer
        Dim DigitalIO As Integer
        Dim DigitalIOfromClient As Integer
        Dim LastDigitalIO As Integer
        Dim DAC_V0 As Long  ' the V0 output
        Dim DAC_V1 As Long  ' the V1 output
        Dim DIO_DDRa As Long  ' the digital port setup
        Dim DIO_PA As Long  ' the output digital port
        Dim PGA_CONa As Long ' programmable gain amplifier a 1 or 128
        Dim PGA_CONb As Long ' programmable gain amplifier b 1 or 128
        Dim convSTA As Long
        Dim convSTB As Long
        Dim StartTimes As Single()
        Dim WaitTimes As Single()
        Dim StartWait As Boolean()
    End Structure

    Declare Function OpenAduDevice Lib "AduHid.DLL" (ByVal iTimeout As Integer) As Integer

    Declare Function WriteAduDevice Lib "AduHid.DLL" (ByVal aduHandle As Integer, ByVal lpBuffer() As Byte, ByVal lNumberOfBytesToWrite As Integer, ByRef lBytesWritten As Integer, ByVal iTimeout As Integer) As Integer

    Declare Function ReadAduDevice Lib "AduHid.DLL" (ByVal aduHandle As Integer, ByVal lpBuffer() As Byte, ByVal lNumberOfBytesToRead As Integer, ByRef lBytesRead As Integer, ByVal iTimeout As Integer) As Integer

    Declare Function CloseAduDevice Lib "AduHid.DLL" (ByVal iOverlapped As Integer) As Integer

    Declare Function ShowAduDeviceList Lib "AduHid.DLL" (ByRef pAduDeviceId As ADU_DEVICE_ID, ByVal sPrompt As String) As Integer

    Declare Function OpenAduDeviceBySerialNumber Lib "AduHid.DLL" (ByVal pSerialNumber As String, ByVal iTimeout As Integer) As Integer

    Declare Function ADUCount Lib "AduHid.DLL" (ByVal iTimeout As Integer) As Integer

    Declare Function GetADU Lib "AduHid.DLL" (ByRef pAduDeviceId As ADU_DEVICE_ID, ByVal iIndex As Integer, ByVal iTimeout As Integer) As Integer


    Public Declare Function OpenAduStream Lib "AduHid.DLL" (ByVal iTimeout As Long) As Long
    Public Declare Function OpenAduStreamByProductId Lib "AduHid.DLL" (ByVal iProductId As Long, ByVal iTimeout As Long) As Long
    Public Declare Function OpenAduStreamBySerialNumber Lib "AduHid.DLL" (ByVal sSerialNumber As String, ByVal iTimeout As Long) As Long
    Public Declare Function ReadAduStream Lib "AduHid.DLL" (ByVal aduHandle As Integer, ByVal lpBuffer() As Byte, ByVal lNumberOfBytesToRead As Integer, ByRef lBytesRead As Integer, ByVal iTimeout As Integer) As Integer
    Public Declare Function CloseAduStream Lib "AduHid.DLL" (ByVal hFile As Long) As Long


    Public LoadCard As DACardObject
    Public starttimeforTimer As Single

    Public CH1noiseMaxDec As Long
    Public CH2noiseMaxDec As Long
    Public CH24anoiseMaxDec As Long
    Public CH24bnoiseMaxDec As Long

    Public CH1noiseMinDec As Long
    Public CH2noiseMinDec As Long
    Public CH24anoiseMinDec As Long
    Public CH24bnoiseMinDec As Long

    Public CH1zero As Long
    Public CH2zero As Long
    Public CH24azero As Long
    Public CH24bzero As Long

    Public CH1calconst As Single
    Public CH2calconst As Single
    Public CH24acalconst As Single
    Public CH24bcalconst As Single
    Public VS As String
    Public VScommand As String
    Public PKTS As Long



    Public Sub WaitForTime(ByVal theTime As Long)
        Dim StartTime As Single

        If theTime = 0 Then
            Exit Sub
        End If

        StartTime = Microsoft.VisualBasic.DateAndTime.Timer

        Do While Microsoft.VisualBasic.DateAndTime.Timer - StartTime < theTime / 1000
            Application.DoEvents()
        Loop
    End Sub
    Public Function UnicodeStringToBytes(
    ByVal str As String) As Byte()

        Return System.Text.Encoding.ASCII.GetBytes(str)
    End Function

    Public Function UnicodeBytesToString(
    ByVal bytes() As Byte) As String

        Return System.Text.Encoding.ASCII.GetString(bytes)
    End Function
End Module